unit fmTextEval;

interface

uses
  SysUtils, Graphics, Forms, StdCtrls, CDBShUtils, Debug, RplDesasm, ComCtrls,
  FmProject, emu48dll, Classes, Controls;

type
  TfrmTextEval = class(TForm)
    Edit1: TEdit;
    Memo1: TRichEdit;
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    procedure GetRes;
  end;

var
  frmTextEval: TfrmTextEval;

implementation

{$R *.DFM}

procedure TfrmTextEval.Edit1KeyPress(Sender: TObject; var Key: Char);
var
  j: integer;
  s: string;
  skeys: string;                                                                // wgg
  t:char;
begin
  if Key=#13 then
  begin
    Memo1.SelAttributes.Style:= [];
    Memo1.Lines.add(Edit1.Text);
    s:= inttohex2(length(Edit1.Text)*2+5, 5);
    revstring(s);
                                                             // wgg modified to handle HP48 and HP49
    s:= 'D9D20'+'C2A20'+s+BinToHexHP(Edit1.Text);            // DOCOL DOCSTR  string STR-> EVAL ->STR SEMI
    if frmProject.IsCalc48 then
    begin
        s:= s+ '62BC1'+'EB3A1'+'B2130';                     // for HP48: STR-> EVAL SEMI
        skeys:= 'O';                                        // EVAL
    end else
    begin
        s:= s+'9DBB3'+'CA593'+'B2130';               // for HP49: STR-> EVAL SEMI  was ->STR +'EBBB3' then SEMI

        t:= EmuCalculatorType;
        if (t = '2') Or (t = 'Q') then
          skeys:= 'N'                                      // wgg EVAL for 49G+ or 48GII
        else
          skeys:= #19'P';                                   // R Shift, EVAL
    end;

    StringToFile(frmProject.HPHeader+'-C'+HexToBinHP(s), 'temp');
    Debugger.LoadFile('temp');
    for j:=0 to 100 do begin application.ProcessMessages; Sleep(1); end;
    debugger.ExecKey(skeys, GetRes);
    Key:= #0;
    Edit1.Clear;                                                        // wgg clear input line if ok
  end;
end;

procedure TfrmTextEval.GetRes;
var
  j: integer;
  prolog: TPrologsList;
  s: string;
begin
  InitPrologues(prolog);

  {   // wgg I dont understand why the result is converted by STR-> so Im skipping this
  repeat
  begin
    Application.ProcessMessages; Sleep(100);
    j:= Debugger.ReadInteger(Debugger.ReadInteger(Debugger.ReadInteger($806F8)));
  end until j=$02A2C;
  }

  j:= Debugger.ReadInteger(Debugger.ReadInteger($806F8));
  s:= DecompObj(j, Debugger.ReadInteger, Debugger.ReadInt64, prolog, nil, nil);
  Memo1.SelAttributes.Style:= [fsBold];
  memo1.Lines.add('--> '+s);                              // wgg was copy(s, 2,length(s)-2)
end;

end.
